<?php

namespace Teknisa\DF\Modules\Saida\Controllers;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Row;
use Zeedhi\Framework\DataSource\DataSet;


class ParamgeralPargeraldfe extends \Teknisa\DF\Controllers\TeknisaCrud {
    protected $dataSourceName = 'paramgeral_pargeraldfe';
    protected $entityManager;
    protected $environment;
    protected $cripto;
    

    public function __construct($crudService, $parameterBag, $environment, $entityManager, $cripto) {
        parent::__construct($crudService, $parameterBag);
        $this->environment = $environment;
        $this->entityManager = $entityManager;
        $this->cripto = $cripto;
    }

    public function save(DTO\Request $request, DTO\Response $response) {
  // $connection = $this->entityManager->getConnection();
//$connection->beginTransaction();
        try {
            $this->dataSourceName = "paramgeral";
            //parent::save($request,$response);
            //var_dump($request->getRow());
            //var_dump($request);die;
            $array = array();
            $row = new Row();
            $row->set('__is_new',  false);
            $row->set('__createdLocal',true);
            $row->set('changed',true);
            $row->set('CDPARGERAL',  $request->getRow()['CDPARGERAL']);
            //$campo1 =  $request->getRow()['IDIMPAVLANNF'];
            $row->set('NRDECITOTANF',  $request->getRow()['NRDECITOTANF']);
            $row->set('IDCONSFISCSA',  $request->getRow()['IDCONSFISCSA']);
            $row->set('IDUTCTRLFISSAID',  $request->getRow()['IDUTCTRLFISSAID']);
            $row->set('IDNFOUTRASNF',  $request->getRow()['IDNFOUTRASNF']);
            $row->set('IDAVNFNREPSA',  $request->getRow()['IDAVNFNREPSA']);
            $row->set('IDBLOQVENPR',  $request->getRow()['IDBLOQVENPR']);
            $row->set('IDBLOQITNFAPUR',  $request->getRow()['IDBLOQITNFAPUR']);
            $row->set('IDUTREIMPRNF',  $request->getRow()['IDUTREIMPRNF']);
            $row->set('NREXEMEMISSAO',  $request->getRow()['NREXEMEMISSAO']);
            $row->set('IDTPLANCDESC',  $request->getRow()['IDTPLANCDESC']);
            $row->set('IDOPPRESENDDIF',  $request->getRow()['IDOPPRESENDDIF']);
            $row->set('IDBLQALTFILCENT',  $request->getRow()['IDBLQALTFILCENT']);
            $row->set('IDNFILTROINSCR',  $request->getRow()['IDNFILTROINSCR']);
            $row->set('IDUTDTPROCTNFE',  $request->getRow()['IDUTDTPROCTNFE']);
            $row->set('IDPARAMEMISRE',  $request->getRow()['IDPARAMEMISRE']);
            $row->set('IDUTSERTPOP',  $request->getRow()['IDUTSERTPOP']);
            $row->set('IDSUGTPOPER',  $request->getRow()['IDSUGTPOPER']);
            $row->set('IDDTEMISDIFDTBC',  $request->getRow()['IDDTEMISDIFDTBC']);
            $row->set('NRDUPLINFS',  $request->getRow()['NRDUPLINFS']);
            $row->set('IDREPLNRDT',  $request->getRow()['IDREPLNRDT']);
            $row->set('IDEMPDESTREPAUT',  $request->getRow()['IDEMPDESTREPAUT']);
            $row->set('IDCALCPESONF', $request->getRow()['IDCALCPESONF']);
            $row->set('IDOBRNCMCADPR',  $request->getRow()['IDOBRNCMCADPR']);
            $row->set('IDPERVISIMPSCRE',  $request->getRow()['IDPERVISIMPSCRE']);
            $row->set('IDUTDTBCDTEMISS',  $request->getRow()['IDUTDTBCDTEMISS']);
            $row->set('IDPERLANCNFOUFI',  $request->getRow()['IDPERLANCNFOUFI']);
            $row->set('IDPERAPROVNFXML',  $request->getRow()['IDPERAPROVNFXML']);
            $row->set('VRFAIXTOLENF',  $request->getRow()['VRFAIXTOLENF']);
            $row->set('IDPERALTCSTFENF',  $request->getRow()['IDPERALTCSTFENF']);
            $row->set('VRPETOLEVRAF',  $request->getRow()['VRPETOLEVRAF']);
            $row->set('IDCONSVLRMAF',  $request->getRow()['IDCONSVLRMAF']);
            $row->set('VRPETOLEQTAF',  $request->getRow()['VRPETOLEQTAF']);
            $row->set('IDCONSVLRMENAF',  $request->getRow()['IDCONSVLRMENAF']);
            $row->set('IDBLOQCMPSAF',  $request->getRow()['IDBLOQCMPSAF']);
            $row->set('IDUTBLOQOPAFPG',  $request->getRow()['IDUTBLOQOPAFPG']);
            $row->set('IDIMPFOVAZAF',  $request->getRow()['IDIMPFOVAZAF']);
            $row->set('NRORG', $this->environment->getNrOrgTrab());
            
            $array[] = $row;
            $dataSet = new DataSet('paramgeral', $array);
            $request2 = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            //var_dump($row);die;
            $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
            $rows = $this->crudService->getRowsToSave($request2, $dataSourceName);
            //var_dump($rows);die;
            $this->crudService->save($dataSourceName, $rows);
            //var_dump($rows);die;
            $this->inserirParametrosGeralDFE($response,$request);

        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
    }
    public function inserirParametrosGeralDFE($response,$request){
        $this->dataSourceName = "pargeraldfe";
        $this->dataSourceNameToSave = "pargeraldfe";
        $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
        $condicaoAdicional = $this->retornaCondicao();
        $resul = $this->realizaConsulta($response,$condicaoAdicional);
        $resul = $resul->getDataSets()[0]->getRows();
        //var_dump($resul);die;
        $array = array();
        //var_dump($array);die;
           $row = new Row();
            if(empty($resul)){
                $row->set('__is_new',true);
            }else{
                $row->set('__is_new',false);
            }
            $row->set('__createdLocal',true);
            $row->set('changed',true);
            $row->set('CDPARAMDFE', '1');
            //$row->set('IDIMPAVLANNF', $campo1);
    /*-----------Campos SMTP Parametros gerais Saida------------------------*/
            $row->set('DSLOGINSMTPGSAID',  $request->getRow()['DSLOGINSMTPGSAID']);
            $row->set('DSSMTPEMAILFGSAID', $request->getRow()['DSSMTPEMAILFGSAID']);
            $rowDoDataset2 = $request->getRow();
            //var_dump($rowDoDataset2);die;
            $boolSenhaAlteradaSaida = $rowDoDataset2['senhaSMTPSaidaAlterada'];
            //var_dump($camposDaRow2);die;
            //$boolSenhaAlteradaSaida = $rowDoDataset2;
            //var_dump($boolSenhaAlteradaSaida);die;
            if($boolSenhaAlteradaSaida){
                $valorDescriptografado = $request->getRow()['CDSENHEMAILFGSAID'];
                //var_dump($valorDescriptografado);die;
                $valorCriptografado = $this->cripto->cripto($valorDescriptografado,2);
                $row->set('CDSENHEMAILFGSAID', $valorCriptografado);
            }else{
              $row->set('CDSENHEMAILFGSAID', $request->getRow()['CDSENHEMAILFGSAID']);
            }
            $row->set('IDUTTLSEMAILGSAID', $request->getRow()['IDUTTLSEMAILGSAID']);
            $row->set('IDUTSSLEMAILGSAID', $request->getRow()['IDUTSSLEMAILGSAID']);
            
            // $row->set('DSLOGINSMTPGENTR', $request->getRow()['DSLOGINSMTPGENTR']);
            // $row->set('DSSMTPEMAILFGENTR', $request->getRow()['DSSMTPEMAILFGENTR']);
            // $rowDoDataset2 = $request->getRow();
            // $camposDaRow2 = $rowDoDataset2['senhaSMTPEntrAlterada'];
            // $boolSenhaAlterada = $camposDaRow2;
            // //var_dump($boolSenhaAlterada);die;
            // if($boolSenhaAlterada){
            //     $valorDescriptografado = $request->getRow()['CDSENHEMAILFGENTR'];
            //     //var_dump($valorDescriptografado);die;
            //     $valorCriptografado = $this->cripto->cripto($valorDescriptografado,2);
            //     $row->set('CDSENHEMAILFGENTR', $valorCriptografado);
            // }else{
            //   $row->set('CDSENHEMAILFGENTR', $request->getRow()['CDSENHEMAILFGENTR']);
            // }
            // $row->set('IDUTTLSEMAILGENTR', $request->getRow()['IDUTTLSEMAILGENTR']);
            // $row->set('IDUTSSLEMAILGENTR', $request->getRow()['IDUTSSLEMAILGENTR']);
            // $row->set('NRORG', $this->environment->getNrOrgTrab());
           
        $array[] = $row;
        
        try {
            $dataSet = new DataSet('pargeraldfe', $array);
            //var_dump($dataSet);die;
            $request3 = new DTO\Request\DataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            //var_dump($request3);die;
            $saveRows = $this->crudService->getRowsToSave($request3,$dataSourceName);
            //var_dump($saveRows);die;
            $this->crudService->save('pargeraldfe', $saveRows);
            
        }catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }

    }
    public function realizaConsulta($response,$conditions) {
        $filterCriteria = new FilterCriteria($this->dataSourceName,$conditions);
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
       // var_dump($newFilterCriteria);die;
        $this->crudService->find($response,$newFilterCriteria);
        //var_dump($this);die;
        return $response;
       //  var_dump($response);die;
    }
    public function retornaCondicao() {
        $conditions = array(
            array(
                "value" => $this->environment->getNrOrgTrab(),
                "operator" => "=",
                "columnName" => "NRORG"
            )
        );
        return $conditions;
    }
    
}